%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%Automatic RFF Algorithms for use with accelerometer signals%%%%%%%
%
%
% Author: Matti Groll (mgroll@bu.edu)
%         Stepp Lab, Boston University, MA
% Date:   2/16/2021
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

addpath('dependencies')
addpath('dependencies\swipe')
addpath('dependencies\halcyon')
% close all; clear; clc;

global min_pitch_set; 
global max_pitch_set;
global maxpkn; 
global perform_fol; 
global stimulicomb;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% you can adjust the following six variables.
min_pitch_set = 50; %default min pitch is 50 Hz
max_pitch_set = 400; %default max pitch is 400 Hz
maxpkn = 3; %initially assume that there will be 3 VCV instances
stimulicomb = 0; %if /afa/, /ifi/, and /ufu/ are recorded separately and we want to save all RFFs from
    %these recordings into one file under the speaker's name, then set
    %stimulicomb to 1, else set stimulicomb to 0.

%Change this to where RFF results will be saved
perform_fol = 'C:\SAMPLE_PERFORMANCE_FOLDER\';

%Change this to the folder location of audio files
folname = 'C:\SAMPLE_FOLDER\';
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%reads in all wave files
allfiles = dir([folname '*.wav']);

%find the location of fricatives
for filei = 1:length(allfiles)
    filename = allfiles(filei).name;
    find_fric_halcyon_ACC(folname, filename);
end

%find cycles used to RFF estimation and estimate RFF from them
for filei = 1:length(allfiles)
    filename = allfiles(filei).name;
    if exist([perform_fol filename(1:end-4)],'dir')
        if exist([perform_fol filename(1:end-4) '\var\fric_param.mat']) %#ok<*ISMT>
            fprintf([filename '\n'])
            find_RFFcycles_ACC_final(folname, filename);
        end
    end
end

%final RFF check. Save into Excel file.
RFFoutput_ACC(allfiles)
% RFFoutput_ACC_max_on(allfiles)

%reject code
%not rejected: 0
%preprocess reject-few periodic cycles: 1 
%unstable: 2
%glottalized: 3
%aperiodic: 4
%sharp transition: 5