% Read in audio file
% aRFF.y  = speech signal (V)
% aRFF.fs = sampling frequency (Hz)
% aRFF.t  = time vector for speech signal (s)
addpath('R:\SteppLab3\Projects\Voice\HSRFF\scripts\version testing\V.2. algorithms + finer F0 estimation\F0 estimation methods\manualRFF\sound samples');
[aRFF.y, aRFF.fs] = audioread('TCH2_AFA.wav');
aRFF.t = linspace(0, length(aRFF.y)/aRFF.fs, length(aRFF.y));

% If there are multiple channels, only read in the first channel
if size(aRFF.y, 2) > 1
    aRFF.y = aRFF.y(:,1);
end

N = length(aRFF.t);                  % Number of samples
aRFF.y = (aRFF.y)./max(abs(aRFF.y)); % Peak-normalize the audio file

% Find F0 contour using Halcyon algorithm and default parameters
param.min_f0 = 50;   % Minimum F0 candidate
param.max_f0 = 600;   % Maximum F0 candidate
param.N_cndt = 100;             % # F0 candidates 
param.L = 4;                    % # cycles within the time window 
param.K = 8;                    % # harmonics used = # of filters in filter bank
param.V = 1;                    % # shifts for instant phase estimates (>0)
param.fstep  = 8;               % Frame input step (controls time resolution)
param.dpstep = 21;              % Dynamic prog. step (# samples to jump)
[ph, th] = halcyon(aRFF.y, aRFF.fs, param); 
aRFF.F0c = interp1(th', ph, aRFF.t', 'pchip', NaN); % F0 contour
aRFF.F0c(isnan(aRFF.F0c)) = 0;